//  TPrintout  WinCassette.
#include "cassprnt.h"
#include "twcwnd.h"
extern TTransRec sideAStrgs, //     .
                 sideBStrgs; //     .

// TCassPrintout::TCassPrintout()
//     .
TCassPrintout::TCassPrintout(const char *title) :
            TPrintout(title)
{
  //     . 
  for (int x=0; x<16; ++x)
  {
	  sideAEdits[x] = sideAStrgs.edit1 + x*38;
	  sideBEdits[x] = sideBStrgs.edit1 + x*38;
  }
}

// TCassPrintout::GetDialoglnfo()
//    , 
//      .
void TCassPrintout::GetDialoglnfo(int &minPage,
		  int &maxPage, int &selFromPage, int &selToPage)
{
  minPage = 0;
  maxPage = 0;
  selFromPage = 0;
  selToPage = 0;
}

// TCassPrintout::PrintPage()
//      
// .     
//  ,    .
void TCassPrintout::PrintPage(int, TRect&, unsigned)
{
  //    
  //   .
  int horDots = DC->GetDeviceCaps(LOGPIXELSX);
  int verDots = DC->GetDeviceCaps(LOGPIXELSY);
  //    .
  DrawLabel(horDots, verDots);
  //      .
  DrawBodyText(horDots, verDots);
  //    .
	DrawTitleText(horDots, verDots);
}

// TCassPrintout::DrawLabel()
//      .
void TCassPrintout::DrawLabel(int horDots, int verDots)
{
  DC->MoveTo(horDots/2, verDots/2);
  DC->LineTo(horDots*4.5, verDots/2);
  DC->LineTo(horDots*4.5, verDots*4.3);
  DC->LineTo(horDots/2, verDots*4.3);
  DC->LineTo(horDots/2, verDots/2);
  DC->MoveTo(horDots/2, verDots*0.75);
  DC->LineTo(horDots*4.5, verDots*0.75);
  DC->MoveTo(horDots/2, verDots*0.93);
  DC->LineTo(horDots*4.5, verDots*0.93);
  DC->MoveTo(horDots/2, verDots*3.1);
  DC->LineTo(horDots*4.5, verDots*3.1);
  DC->MoveTo(horDots/2, verDots*3.62);
  DC->LineTo(horDots*4.5, verDots*3.62);
  DC->MoveTo(horDots*2.5, verDots*0.75);
  DC->LineTo(horDots*2.5, verDots*3.1);
}

// TCassPrintout::DrawBodyText()
//      
//  .
void TCassPrintout::DrawBodyText(int horDots,int verDots)
{
  TEXTMETRIC metrics;//   .
  char s[80];        //   .
  //       .
  TFont *newFont = CreateCassFont(horDots/30,verDots/8);
  DC->SelectObject(*newFont);
  //    .
  DC->GetTextMetrics(metrics);
  //        .
  strcpy(s, "Side :");
  strcpy(&s[strlen(s)], sideAStrgs.sideTitle);
  DC->TextOut(horDots*0.6, verDots*0.77, s, strlen(s));
  strcpy(s, "Side B:");
  strcpy(&s[strlen(s)], sideBStrgs.sideTitle);
  DC->TextOut(horDots*2.6, verDots*0.77, s, strlen(s));
  //        .
  for (int x=0; x<16; ++x)
  {
	 DC->TextOut((int) (horDots*0.6), (int)
		 (verDots + x*metrics.tmHeight), sideAEdits[x],
		  strlen(sideAEdits[x]));
	 DC->TextOut((int) (horDots*2.6), (int)
		 (verDots + x*metrics.tmHeight), sideBEdits[x],
		  strlen(sideBEdits[x]));
  }
  delete newFont;
}

// TCassPrintout::DrawTitleText()
//      .
void TCassPrintout::DrawTitleText(int horDots,int verDots)
{
  int strWidth; //   .
  //    .
  TFont *newFont = CreateCassFont(horDots/20, verDots/20);
  DC->SelectObject(*newFont);
  //      .
  TSize size = DC->GetTextExtent(sideAStrgs.cassTitle,
		 strlen(sideAStrgs.cassTitle));
  //    .
  strWidth = size.cx;
  //    .
  DC->TextOut((horDots*2.5)-(strWidth/2),verDots*0.52,
  sideAStrgs.cassTitle,strlen(sideAStrgs.cassTitle));
  DC->TextOut((horDots*2.5)-(strWidth/2),verDots*3.25,
  sideAStrgs.cassTitle,strlen(sideAStrgs.cassTitle));
  delete newFont;
}

// TCassPrintout::CreateCassFont()
//       .
//     
//   .
TFont* TCassPrintout::CreateCassFont(int hSize, int vSize)
{
  LOGFONT cassLogFont; //   .
  //   LOGFONT.
  cassLogFont.lfHeight = vSize;
  cassLogFont.lfWidth = hSize;
  cassLogFont.lfEscapement = 0;
  cassLogFont.lfOrientation = 0;
  cassLogFont.lfWeight = FW_NORMAL;
  cassLogFont.lfItalic = 0;
  cassLogFont.lfUnderline = 0;
  cassLogFont.lfStrikeOut = 0;
  cassLogFont.lfCharSet   = ANSI_CHARSET;
  cassLogFont.lfOutPrecision = OUT_DEFAULT_PRECIS;
  cassLogFont.lfClipPrecision = CLIP_DEFAULT_PRECIS;
  cassLogFont.lfQuality = PROOF_QUALITY;
  cassLogFont.lfPitchAndFamily = VARIABLE_PITCH | FF_ROMAN;
  strcpy(cassLogFont.lfFaceName, "Times New Roman");
  //   .
  return new TFont(&cassLogFont);
}